=== debian/control ===
Source: subnetcalc
Section: net
Priority: optional
Maintainer: Thomas Dreibholz <thomas.dreibholz@gmail.com>
Homepage: https://www.nntb.no/~dreibh/subnetcalc/
Vcs-Git: https://github.com/dreibh/subnetcalc.git
Vcs-Browser: https://github.com/dreibh/subnetcalc
Build-Depends: cmake,
               debhelper-compat (= 13),
               gettext,
               libgeoip-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no

Package: subnetcalc
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: iproute2,
            iputils-tracepath,
            ping | iputils-ping,
            rsplib-tools,
            traceroute | inetutils-traceroute,
            whois
Description: IPv4/IPv6 Subnet Calculator
 SubNetCalc is an IPv4/IPv6 subnet address calculator. For given IPv4 or
 IPv6 address and netmask or prefix length, it calculates network address,
 broadcast address, maximum number of hosts and host address range. The
 output is colourized for better readability (e.g. network part, host part).
 Also, it prints the addresses in binary format for better understandability.
 Furthermore, it can identify the address type (e.g. multicast, unique local,
 site local, etc.) and extract additional information from the address
 (e.g. type, scope, interface ID, etc.). Finally, it can generate
 IPv6 unique local prefixes.
